/*
Copyright (C) BABEC. All rights reserved.
Copyright (C) THL A29 Limited, a Tencent company. All rights reserved.

SPDX-License-Identifier: Apache-2.0
*/

package vm

import (
	"fmt"
	"strings"

	"chainmaker.org/chainmaker/protocol/v2"
)

func PrintTxReadSet(txSimContext protocol.TxSimContext) {
	txSimCxtImpl, ok := txSimContext.(*txSimContextImpl)
	if !ok {
		return
	}

	for key, txRead := range txSimCxtImpl.txReadKeyMap {
		if strings.Index(key, "Contract:") >= 0 || strings.Index(key, "ContractByteCode:") >= 0 {
			fmt.Printf("[tx read set]: %v ==> {contract_name = '%v', key = '%s', len(val) = '%d'} \n", key, txRead.ContractName, txRead.Key, len(txRead.Value))
		} else {
			fmt.Printf("[tx read set]: %v ==> {contract_name = '%v', key = '%s', val = '%s'} \n", key, txRead.ContractName, txRead.Key, txRead.Value)
		}
	}
}

func PrintTxWriteSet(txSimContext protocol.TxSimContext) {
	txSimCxtImpl, ok := txSimContext.(*txSimContextImpl)
	if !ok {
		return
	}

	for key, txWrite := range txSimCxtImpl.txWriteKeyMap {
		if strings.Index(key, "Contract:") >= 0 || strings.Index(key, "ContractByteCode:") >= 0 {
			fmt.Printf("[tx write set]: %v ==>{contract_name = '%v', key = '%s', len(val) = '%d'} \n", key, txWrite.ContractName, txWrite.Key, len(txWrite.Value))
		} else {
			fmt.Printf("[tx write set]: %v ==> {contract_name = '%v', key = '%s', val = '%s'} \n", key, txWrite.ContractName, txWrite.Key, txWrite.Value)
		}
	}
}
